require_dependency "aws_elb_health_check/application_controller"

module AwsElbHealthCheck
  class HealthChecksController < ApplicationController
    def index
      if secret_key.present?
        if params[:check_key] == secret_key
          head :ok
        else
          head 403
        end
      else
        Rails.logger.error("Application is not configured properly: '#{AWS_ELB_HEALTH_CHECK_SECRET_KEY_ENV_VAR}' is not set up, so no health check can ever pass")
        head 501
      end
    end

  private

    AWS_ELB_HEALTH_CHECK_SECRET_KEY_ENV_VAR = "AWS_ELB_HEALTH_CHECK_SECRET_KEY"

    def secret_key
      ENV[AWS_ELB_HEALTH_CHECK_SECRET_KEY_ENV_VAR]
    end
  end
end
